Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTestdataAwareTrainingStrategy.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTestdataAwareTrainingStrategy.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTestdataAwareTrainingStrategy.java	(revision 135)
@@ -1,2 +1,3 @@
+
 package de.ugoe.cs.cpdp.training;
 
@@ -4,11 +5,37 @@
 import weka.core.Instances;
 
+/**
+ * <p>
+ * Training strategy for training with access to the target data and one data set per input product.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface ISetWiseTestdataAwareTrainingStrategy extends ITrainer {
 
+    /**
+     * <p>
+     * Applies the training strategy.
+     * </p>
+     *
+     * @param traindataSet
+     *            the training data per product
+     * @param testdata
+     *            the test data from the target product
+     */
     void apply(SetUniqueList<Instances> traindataSet, Instances testdata);
 
+    /**
+     * <p>
+     * returns the name of the training strategy
+     * </p>
+     *
+     * @return the name
+     */
     String getName();
-    
+
+    // TODO: these two methods look like they should be removed and instead be handled using the parameters
     void setMethod(String method);
+
     void setThreshold(String threshold);
 }
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTrainingStrategy.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTrainingStrategy.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ISetWiseTrainingStrategy.java	(revision 135)
@@ -19,9 +19,30 @@
 import weka.core.Instances;
 
-// Bagging Strategy: separate models for each training data set
+/**
+ * <p>
+ * Training strategy for training with one data set per input product.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface ISetWiseTrainingStrategy extends ITrainer {
 
+    /**
+     * <p>
+     * Applies the training strategy.
+     * </p>
+     *
+     * @param traindataSet
+     *            the training data per product
+     */
     void apply(SetUniqueList<Instances> traindataSet);
 
+    /**
+     * <p>
+     * returns the name of the training strategy
+     * </p>
+     *
+     * @return the name
+     */
     String getName();
 }
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITestAwareTrainingStrategy.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITestAwareTrainingStrategy.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITestAwareTrainingStrategy.java	(revision 135)
@@ -3,8 +3,32 @@
 import weka.core.Instances;
 
+/**
+ * <p>
+ * Training strategy for training with access to the target data and the training data as a single data set.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface ITestAwareTrainingStrategy extends ITrainer {
     
+    /**
+     * <p>
+     * Applies the training strategy.
+     * </p>
+     *
+     * @param traindata
+     *            the training data for all products
+     * @param testdata
+     *            the test data from the target product
+     */
     void apply(Instances testdata, Instances traindata);
 
+    /**
+     * <p>
+     * returns the name of the training strategy
+     * </p>
+     *
+     * @return the name
+     */
     String getName();
 }
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainer.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainer.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainer.java	(revision 135)
@@ -17,4 +17,11 @@
 import de.ugoe.cs.cpdp.IParameterizable;
 
+/**
+ * <p>
+ * Marker interface for all CrossPare trainers.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface ITrainer extends IParameterizable {
 
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainingStrategy.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainingStrategy.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/ITrainingStrategy.java	(revision 135)
@@ -17,8 +17,30 @@
 import weka.core.Instances;
 
+/**
+ * <p>
+ * Training strategy for training with the training data as a single data set.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface ITrainingStrategy extends ITrainer {
 
+    /**
+     * <p>
+     * Applies the training strategy.
+     * </p>
+     *
+     * @param traindata
+     *            the training data for all target products
+     */
     void apply(Instances traindata);
 
+    /**
+     * <p>
+     * returns the name of the training strategy
+     * </p>
+     *
+     * @return the name
+     */
     String getName();
 }
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/IWekaCompatibleTrainer.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/IWekaCompatibleTrainer.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/IWekaCompatibleTrainer.java	(revision 135)
@@ -17,8 +17,29 @@
 import weka.classifiers.Classifier;
 
+/**
+ * <p>
+ * Common interface for all training strategies that internally use the {@link Classifier} from WEKA. 
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
 public interface IWekaCompatibleTrainer extends ITrainer {
 
+    /**
+     * <p>
+     * returns the WEKA classifier
+     * </p>
+     *
+     * @return the classifier
+     */
     Classifier getClassifier();
 
+    /**
+     * <p>
+     * returns the name of the training strategy
+     * </p>
+     *
+     * @return the name
+     */
     String getName();
 }
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/QuadTree.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/QuadTree.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/QuadTree.java	(revision 135)
@@ -24,45 +24,103 @@
 
 /**
- * QuadTree implementation
+ * <p>
+ * QuadTree implementation.
+ * </p>
+ * <p>
+ * QuadTree gets a list of instances and then recursively split them into 4 children For this it
+ * uses the median of the 2 values x,y.
+ * </p>
  * 
- * QuadTree gets a list of instances and then recursively split them into 4 childs For this it uses
- * the median of the 2 values x,y
+ * @author Alexander Trautsch
  */
 public class QuadTree {
 
-    /* 1 parent or null */
+    /**
+     * 1 parent or null
+     */
     private QuadTree parent = null;
 
-    /* 4 childs, 1 per quadrant */
+    /**
+     * north-west quadrant
+     */
     private QuadTree child_nw;
+
+    /**
+     * north-east quadrant
+     */
     private QuadTree child_ne;
+
+    /**
+     * south-east quadrant
+     */
     private QuadTree child_se;
+
+    /**
+     * south-west quadrant
+     */
     private QuadTree child_sw;
 
-    /* list (only helps with generation of list of childs!) */
+    /**
+     * helper list for child quadrant generation
+     */
     private ArrayList<QuadTree> l = new ArrayList<QuadTree>();
 
-    /* level only used for debugging */
+    /**
+     * debugging attribute
+     */
     public int level = 0;
 
-    /* size of the quadrant */
+    /**
+     * size of the quadrant in x-dimension
+     */
     private double[] x;
+
+    /**
+     * size of the quadrant in y-dimension
+     */
     private double[] y;
 
+    /**
+     * debugging parameter
+     */
     public static boolean verbose = false;
+
+    /**
+     * global size of the QuadTree.
+     */
     public static int size = 0;
+
+    /**
+     * recursion parameter alpha
+     */
     public static double alpha = 0;
 
-    /* cluster payloads */
+    /**
+     * data for each cluster
+     */
     public static ArrayList<ArrayList<QuadTreePayload<Instance>>> ccluster =
         new ArrayList<ArrayList<QuadTreePayload<Instance>>>();
 
-    /* cluster sizes (index is cluster number, arraylist is list of boxes (x0,y0,x1,y1) */
+    /**
+     * cluster sizes (index is cluster number, {@link ArrayList} is list of boxes (x0,y0,x1,y1
+     */
     public static HashMap<Integer, ArrayList<Double[][]>> csize =
         new HashMap<Integer, ArrayList<Double[][]>>();
 
-    /* payload of this instance */
+    /**
+     * data within this quadrant
+     */
     private ArrayList<QuadTreePayload<Instance>> payload;
 
+    /**
+     * <p>
+     * Constructor. Creates a new QuadTree.
+     * </p>
+     *
+     * @param parent
+     *            parent of this tree
+     * @param payload
+     *            data within the quadrant
+     */
     public QuadTree(QuadTree parent, ArrayList<QuadTreePayload<Instance>> payload) {
         this.parent = parent;
@@ -70,4 +128,10 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see java.lang.Object#toString()
+     */
+    @Override
     public String toString() {
         String n = "";
@@ -81,8 +145,10 @@
 
     /**
+     * <p>
      * Returns the payload, used for clustering in the clustering list we only have children with
-     * paylod
-     * 
-     * @return payload
+     * payload
+     * </p>
+     * 
+     * @return payload the payload
      */
     public ArrayList<QuadTreePayload<Instance>> getPayload() {
@@ -91,9 +157,11 @@
 
     /**
-     * Calculate the density of this quadrant
-     * 
-     * density = number of instances / global size (all instances)
-     * 
-     * @return density
+     * <p>
+     * Calculate the density of this quadrant as
+     * <ul>
+     * <li>density = number of instances / global size (all instances)</li>
+     * </ul>
+     * 
+     * @return density the density
      */
     public double getDensity() {
@@ -103,4 +171,14 @@
     }
 
+    /**
+     * <p>
+     * sets the size coordinates of the quadrant
+     * </p>
+     *
+     * @param x
+     *            x-dimension
+     * @param y
+     *            y-dimension
+     */
     public void setSize(double[] x, double[] y) {
         this.x = x;
@@ -108,4 +186,11 @@
     }
 
+    /**
+     * <p>
+     * returns the size of the quadrant
+     * </p>
+     *
+     * @return size of the current quadrant
+     */
     public double[][] getSize() {
         return new double[][]
@@ -113,4 +198,11 @@
     }
 
+    /**
+     * <p>
+     * returns the size of the quadrant
+     * </p>
+     *
+     * @return size of the current quadrant
+     */
     public Double[][] getSizeDouble() {
         Double[] tmpX = new Double[2];
@@ -128,5 +220,7 @@
 
     /**
-     * TODO: DRY, median ist immer dasselbe
+     * <p>
+     * calculates the median for the x axis
+     * </p>
      * 
      * @return median for x
@@ -161,4 +255,11 @@
     }
 
+    /**
+     * <p>
+     * calculates the median for the y axis
+     * </p>
+     * 
+     * @return median for y
+     */
     private double getMedianForY() {
         double med_y = 0;
@@ -191,7 +292,9 @@
 
     /**
-     * Reurns the number of instances in the payload
-     * 
-     * @return int number of instances
+     * <p>
+     * Returns the number of instances in the payload
+     * </p>
+     * 
+     * @return number of instances
      */
     public int getNumbers() {
@@ -204,5 +307,7 @@
 
     /**
+     * <p>
      * Calculate median values of payload for x, y and split into 4 sectors
+     * </p>
      * 
      * @return Array of QuadTree nodes (4 childs)
@@ -295,9 +400,12 @@
 
     /**
-     * TODO: static method
-     * 
+     * <p>
+     * creates the children of a QuadTree and recursively splits them as well
+     * </p>
+     *
      * @param q
-     */
-    public void recursiveSplit(QuadTree q) {
+     *            tree that is split
+     */
+    public static void recursiveSplit(QuadTree q) {
         if (QuadTree.verbose) {
             System.out.println("splitting: " + q);
@@ -310,8 +418,8 @@
             try {
                 QuadTree[] childs = q.split();
-                this.recursiveSplit(childs[0]);
-                this.recursiveSplit(childs[1]);
-                this.recursiveSplit(childs[2]);
-                this.recursiveSplit(childs[3]);
+                recursiveSplit(childs[0]);
+                recursiveSplit(childs[1]);
+                recursiveSplit(childs[2]);
+                recursiveSplit(childs[3]);
             }
             catch (Exception e) {
@@ -322,9 +430,10 @@
 
     /**
-     * returns an list of childs sorted by density
+     * <p>
+     * returns an list of children sorted by density
+     * </p>
      * 
      * @param q
      *            QuadTree
-     * @return list of QuadTrees
      */
     private void generateList(QuadTree q) {
@@ -350,5 +459,7 @@
 
     /**
+     * <p>
      * Checks if passed QuadTree is neighboring to us
+     * </p>
      * 
      * @param q
@@ -396,14 +507,21 @@
 
     /**
+     * <p>
      * Perform pruning and clustering of the quadtree
-     * 
+     * </p>
+     * <p>
      * Pruning according to: Tim Menzies, Andrew Butcher, David Cok, Andrian Marcus, Lucas Layman,
      * Forrest Shull, Burak Turhan, Thomas Zimmermann,
      * "Local versus Global Lessons for Defect Prediction and Effort Estimation," IEEE Transactions
      * on Software Engineering, vol. 39, no. 6, pp. 822-834, June, 2013
-     * 
-     * 1) get list of leaf quadrants 2) sort by their density 3) set stop_rule to 0.5 * highest
-     * Density in the list 4) merge all nodes with a density > stop_rule to the new cluster and
-     * remove all from list 5) repeat
+     * </p>
+     * <ol>
+     * <li>get list of leaf quadrants</li>
+     * <li>sort by their density</li>
+     * <li>set stop_rule to 0.5*highest Density in the list</li>
+     * <li>merge all nodes with a density > stop_rule to the new cluster and remove all from list
+     * </li>
+     * <li>repeat</li>
+     * </ol>
      * 
      * @param q
@@ -479,4 +597,10 @@
     }
 
+    /**
+     * <p>
+     * debugging function that prints information about the QuadTree
+     * </p>
+     *
+     */
     public void printInfo() {
         System.out.println("we have " + ccluster.size() + " clusters");
@@ -488,5 +612,7 @@
 
     /**
+     * <p>
      * Helper Method to get a sorted list (by density) for all children
+     * </p>
      * 
      * @param q
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaggingTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaggingTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaggingTraining.java	(revision 135)
@@ -29,11 +29,10 @@
 
 /**
- * Programmatic WekaBaggingTraining
- * 
- * first parameter is Trainer Name. second parameter is class name
- * 
- * all subsequent parameters are configuration params (for example for trees) Cross Validation
- * params always come last and are prepended with -CVPARAM
- * 
+ * <p>
+ * The first parameter is the trainer name, second parameter is class name. All subsequent
+ * parameters are configuration parameters of the algorithms. Cross validation parameters always
+ * come last and are prepended with -CVPARAM
+ * </p>
+ * <p>
  * XML Configurations for Weka Classifiers:
  * 
@@ -45,10 +44,20 @@
  * }
  * </pre>
+ * </p>
  * 
+ * @author Alexander Trautsch
  */
 public class WekaBaggingTraining extends WekaBaseTraining implements ISetWiseTrainingStrategy {
 
+    /**
+     * the classifier
+     */
     private final TraindatasetBagging classifier = new TraindatasetBagging();
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.WekaBaseTraining#getClassifier()
+     */
     @Override
     public Classifier getClassifier() {
@@ -56,4 +65,11 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see
+     * de.ugoe.cs.cpdp.training.ISetWiseTrainingStrategy#apply(org.apache.commons.collections4.list.
+     * SetUniqueList)
+     */
     @Override
     public void apply(SetUniqueList<Instances> traindataSet) {
@@ -66,12 +82,33 @@
     }
 
+    /**
+     * <p>
+     * Helper class for bagging classifiers.
+     * </p>
+     * 
+     * @author Steffen Herbold
+     */
     public class TraindatasetBagging extends AbstractClassifier {
 
+        /**
+         * default serialization ID.
+         */
         private static final long serialVersionUID = 1L;
 
+        /**
+         * internal storage of the training data
+         */
         private List<Instances> trainingData = null;
 
+        /**
+         * bagging classifier for each training data set
+         */
         private List<Classifier> classifiers = null;
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.AbstractClassifier#classifyInstance(weka.core.Instance)
+         */
         @Override
         public double classifyInstance(Instance instance) {
@@ -115,4 +152,15 @@
         }
 
+        /**
+         * <p>
+         * trains a new dataset wise bagging classifier
+         * </p>
+         *
+         * @param traindataSet
+         *            the training data per prodcut
+         * @throws Exception
+         *             thrown if an error occurs during the training of the classifiers for any
+         *             product
+         */
         public void buildClassifier(SetUniqueList<Instances> traindataSet) throws Exception {
             classifiers = new LinkedList<>();
@@ -126,4 +174,9 @@
         }
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances traindata) throws Exception {
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaseTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaseTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaBaseTraining.java	(revision 135)
@@ -27,19 +27,47 @@
 
 /**
- * WekaBaseTraining2
+ * <p>
+ * Allows specification of the Weka classifier and its params in the XML experiment configuration.
+ * </p>
+ * <p>
+ * Important conventions of the XML format: Cross Validation params always come last and are
+ * prepended with -CVPARAM.<br>
+ * Example:
  * 
- * Allows specification of the Weka classifier and its params in the XML experiment configuration.
+ * <pre>
+ * {@code
+ * <trainer name="WekaTraining" param="RandomForestLocal weka.classifiers.trees.RandomForest -CVPARAM I 5 25 5"/>
+ * }
+ * </pre>
  * 
- * Important conventions of the XML format: Cross Validation params always come last and are
- * prepended with -CVPARAM Example: <trainer name="WekaTraining"
- * param="RandomForestLocal weka.classifiers.trees.RandomForest -CVPARAM I 5 25 5"/>
+ * @author Alexander Trautsch
  */
 public abstract class WekaBaseTraining implements IWekaCompatibleTrainer {
 
+    /**
+     * reference to the Weka classifier
+     */
     protected Classifier classifier = null;
+
+    /**
+     * qualified class name of the weka classifier
+     */
     protected String classifierClassName;
+
+    /**
+     * name of the classifier
+     */
     protected String classifierName;
+
+    /**
+     * parameters of the training
+     */
     protected String[] classifierParams;
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.IParameterizable#setParameter(java.lang.String)
+     */
     @Override
     public void setParameter(String parameters) {
@@ -58,7 +86,12 @@
         classifierParams = Arrays.copyOfRange(params, 2, params.length);
 
-        //classifier = setupClassifier();
+        // classifier = setupClassifier();
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.IWekaCompatibleTrainer#getClassifier()
+     */
     @Override
     public Classifier getClassifier() {
@@ -66,4 +99,11 @@
     }
 
+    /**
+     * <p>
+     * helper function that sets up the Weka classifier including its parameters
+     * </p>
+     *
+     * @return
+     */
     protected Classifier setupClassifier() {
         Classifier cl = null;
@@ -95,8 +135,8 @@
             cl = obj;
 
-            if( cl instanceof Vote ) {
+            if (cl instanceof Vote) {
                 Vote votingClassifier = (Vote) cl;
-                for( Classifier classifier : votingClassifier.getClassifiers() ) {
-                    if( classifier instanceof BayesNet ) {
+                for (Classifier classifier : votingClassifier.getClassifiers()) {
+                    if (classifier instanceof BayesNet) {
                         ((BayesNet) classifier).setUseADTree(false);
                     }
@@ -141,4 +181,9 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.IWekaCompatibleTrainer#getName()
+     */
     @Override
     public String getName() {
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLASERTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLASERTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLASERTraining.java	(revision 135)
@@ -24,8 +24,7 @@
 import weka.core.Instances;
 
-
 /**
  * <p>
- * TODO comment
+ * Implements training following the LASER classification scheme.
  * </p>
  * 
@@ -34,6 +33,14 @@
 public class WekaLASERTraining extends WekaBaseTraining implements ITrainingStrategy {
 
+    /**
+     * Internal classifier used for LASER.
+     */
     private final LASERClassifier internalClassifier = new LASERClassifier();
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.WekaBaseTraining#getClassifier()
+     */
     @Override
     public Classifier getClassifier() {
@@ -41,4 +48,9 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.ITrainingStrategy#apply(weka.core.Instances)
+     */
     @Override
     public void apply(Instances traindata) {
@@ -51,49 +63,73 @@
     }
 
+    /**
+     * <p>
+     * Internal helper class that defines the laser classifier.
+     * </p>
+     * 
+     * @author Steffen Herbold
+     */
     public class LASERClassifier extends AbstractClassifier {
 
+        /**
+         * Default serial ID.
+         */
         private static final long serialVersionUID = 1L;
-        
+
+        /**
+         * Internal reference to the classifier.
+         */
         private Classifier laserClassifier = null;
+
+        /**
+         * Internal storage of the training data required for NN analysis.
+         */
         private Instances traindata = null;
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.AbstractClassifier#classifyInstance(weka.core.Instance)
+         */
         @Override
         public double classifyInstance(Instance instance) throws Exception {
             List<Integer> closestInstances = new LinkedList<>();
             double minDistance = Double.MAX_VALUE;
-            for( int i=0; i<traindata.size(); i++ ) {
+            for (int i = 0; i < traindata.size(); i++) {
                 double distance = WekaUtils.hammingDistance(instance, traindata.get(i));
-                if( distance<minDistance) {
+                if (distance < minDistance) {
                     minDistance = distance;
                 }
             }
-            for( int i=0; i<traindata.size(); i++ ) {
+            for (int i = 0; i < traindata.size(); i++) {
                 double distance = WekaUtils.hammingDistance(instance, traindata.get(i));
-                if( distance<=minDistance ) {
+                if (distance <= minDistance) {
                     closestInstances.add(i);
                 }
             }
-            if( closestInstances.size()==1 ) {
+            if (closestInstances.size() == 1) {
                 int closestIndex = closestInstances.get(0);
                 Instance closestTrainingInstance = traindata.get(closestIndex);
                 List<Integer> closestToTrainingInstance = new LinkedList<>();
                 double minTrainingDistance = Double.MAX_VALUE;
-                for( int i=0; i<traindata.size(); i++ ) {
-                    if( closestIndex!=i ) {
-                        double distance = WekaUtils.hammingDistance(closestTrainingInstance, traindata.get(i));
-                        if( distance<minTrainingDistance ) {
+                for (int i = 0; i < traindata.size(); i++) {
+                    if (closestIndex != i) {
+                        double distance =
+                            WekaUtils.hammingDistance(closestTrainingInstance, traindata.get(i));
+                        if (distance < minTrainingDistance) {
                             minTrainingDistance = distance;
                         }
                     }
                 }
-                for( int i=0; i<traindata.size(); i++ ) {
-                    if( closestIndex!=i ) {
-                        double distance = WekaUtils.hammingDistance(closestTrainingInstance, traindata.get(i));
-                        if( distance<=minTrainingDistance ) {
+                for (int i = 0; i < traindata.size(); i++) {
+                    if (closestIndex != i) {
+                        double distance =
+                            WekaUtils.hammingDistance(closestTrainingInstance, traindata.get(i));
+                        if (distance <= minTrainingDistance) {
                             closestToTrainingInstance.add(i);
                         }
                     }
                 }
-                if( closestToTrainingInstance.size()==1 ) {
+                if (closestToTrainingInstance.size() == 1) {
                     return laserClassifier.classifyInstance(instance);
                 }
@@ -101,14 +137,14 @@
                     double label = Double.NaN;
                     boolean allEqual = true;
-                    for( Integer index : closestToTrainingInstance ) {
-                        if( Double.isNaN(label) ) {
+                    for (Integer index : closestToTrainingInstance) {
+                        if (Double.isNaN(label)) {
                             label = traindata.get(index).classValue();
                         }
-                        else if( label!=traindata.get(index).classValue() ) {
+                        else if (label != traindata.get(index).classValue()) {
                             allEqual = false;
                             break;
                         }
                     }
-                    if( allEqual ) {
+                    if (allEqual) {
                         return label;
                     }
@@ -117,17 +153,18 @@
                     }
                 }
-            } else {
+            }
+            else {
                 double label = Double.NaN;
                 boolean allEqual = true;
-                for( Integer index : closestInstances ) {
-                    if( Double.isNaN(label) ) {
+                for (Integer index : closestInstances) {
+                    if (Double.isNaN(label)) {
                         label = traindata.get(index).classValue();
                     }
-                    else if( label!=traindata.get(index).classValue() ) {
+                    else if (label != traindata.get(index).classValue()) {
                         allEqual = false;
                         break;
                     }
                 }
-                if( allEqual ) {
+                if (allEqual) {
                     return label;
                 }
@@ -138,4 +175,9 @@
         }
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances traindata) throws Exception {
Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLocalEMTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLocalEMTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/WekaLocalEMTraining.java	(revision 135)
@@ -33,20 +33,33 @@
 
 /**
- * WekaLocalEMTraining
+ * <p>
+ * Local Trainer with EM Clustering for data partitioning. Currently supports only EM Clustering.
+ * </p>
+ * <ol>
+ * <li>Cluster training data</li>
+ * <li>for each cluster train a classifier with training data from cluster</li>
+ * <li>match test data instance to a cluster, then classify with classifier from the cluster</li>
+ * </ol>
  * 
- * Local Trainer with EM Clustering for data partitioning. Currently supports only EM Clustering.
+ * XML configuration:
  * 
- * 1. Cluster training data 2. for each cluster train a classifier with training data from cluster
- * 3. match test data instance to a cluster, then classify with classifier from the cluster
- * 
- * XML configuration: <!-- because of clustering --> <preprocessor name="Normalization" param=""/>
- * 
- * <!-- cluster trainer --> <trainer name="WekaLocalEMTraining"
- * param="NaiveBayes weka.classifiers.bayes.NaiveBayes" />
+ * <pre>
+ * {@code
+ * <trainer name="WekaLocalEMTraining" param="NaiveBayes weka.classifiers.bayes.NaiveBayes" />
+ * }
+ * </pre>
  */
 public class WekaLocalEMTraining extends WekaBaseTraining implements ITrainingStrategy {
 
+    /**
+     * the classifier
+     */
     private final TraindatasetCluster classifier = new TraindatasetCluster();
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.WekaBaseTraining#getClassifier()
+     */
     @Override
     public Classifier getClassifier() {
@@ -54,4 +67,9 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.ITrainingStrategy#apply(weka.core.Instances)
+     */
     @Override
     public void apply(Instances traindata) {
@@ -64,11 +82,31 @@
     }
 
+    /**
+     * <p>
+     * Weka classifier for the local model with EM clustering.
+     * </p>
+     * 
+     * @author Alexander Trautsch
+     */
     public class TraindatasetCluster extends AbstractClassifier {
 
+        /**
+         * default serializtion ID
+         */
         private static final long serialVersionUID = 1L;
 
+        /**
+         * EM clusterer used
+         */
         private EM clusterer = null;
 
+        /**
+         * classifiers for each cluster
+         */
         private HashMap<Integer, Classifier> cclassifier;
+
+        /**
+         * training data for each cluster
+         */
         private HashMap<Integer, Instances> ctraindata;
 
@@ -107,4 +145,9 @@
         }
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.AbstractClassifier#classifyInstance(weka.core.Instance)
+         */
         @Override
         public double classifyInstance(Instance instance) {
@@ -139,4 +182,9 @@
         }
 
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances traindata) throws Exception {
